﻿'   Exefunction : example of plug im! module
'   IFPEN LS 2019
'   Adapted from exefunction.cpp MM 2018

Module Module1
    Sub Main()
        '   Read the plug im PAR File
        Dim PiPR As New PlugimPARReader
        Dim ret As Integer
        ret = PiPR.ReadParFile()
        If ret <> 0 Then
            Environment.Exit(ret)
        End If
        '   input filename
        Dim fnIN As String = PiPR.GetINFile
        '   output filename
        Dim fnOUT As String = PiPR.GetOUTFile
        '   preview filename
        Dim fnOUTPREV As String = PiPR.GetPREVFile
        '   example of string parameter (LStr or Bool GUI type)
        Dim str As String = PiPR.GetStrFromTag("strid")
        Dim bool As String = PiPR.GetStrFromTag("boolid")
        '   example of double parameter (NUD GUI type)
        Dim dbl As Double = PiPR.GetDoubleFromTag("doubleid")
        '   example of integer parameter (NUD GUI type)
        Dim integ As Int32 = PiPR.GetIntFromTag("intid")
        '   Loading image, use fnIN
        '   8 bits format or RGB 8 bits format
        Dim IM As New F2UC
        Dim IMRGB As New F2UCRGB
        Dim loadok As Boolean = True
        Dim isrgb As Boolean = IMRGB.Load(fnIN)
        If (isrgb) Then
            IM.Resize(IMRGB.W, IMRGB.H)
        Else
            loadok = IM.Load(fnIN)
            '   Send a message to show in plug im!, use console message
            If (loadok) Then
                Console.WriteLine("Loading OK!")
            Else
                Console.WriteLine("Loading error...")
                Environment.Exit(0)
            End If
        End If
        '   Get width and height 
        Dim W As Int32 = IM.W
        Dim H As Int32 = IM.H
        Dim T As Int32 = IM.NumPix
        '   RGB image
        Dim R As F2UC = IM.CloneSize
        Dim RRGB As F2UCRGB = IMRGB.CloneSize
        Dim i, j As Integer
        If (bool = "true") Then
            '   Browse all the pixels and calculate the negative image
            If Not (isrgb) Then
                For i = 0 To T - 1
                    R(i) = 255 - IM(i)
                Next
            Else
                '   for RGB image, process all chanels separately
                For i = 0 To T - 1
                    RRGB(i).R = 255 - IMRGB(i).R
                    RRGB(i).G = 255 - IMRGB(i).G
                    RRGB(i).B = 255 - IMRGB(i).B
                Next
            End If
            Console.WriteLine("Negative image processed.")
            '   Save a preview image to display in plug im!, use fnOUTPREV
            If Not (isrgb) Then
                R.Save(fnOUTPREV)
            Else
                RRGB.Save(fnOUTPREV)
            End If
        Else
            '   Another way to browse all the pixels, and now calculate horizontal gradient image
            Dim val As Int32
            If Not (isrgb) Then
                For j = 0 To H - 1
                    For i = 1 To W - 2
                        val = CInt(IM(j, i - 1)) - CInt(IM(j, i + 1))
                        If (val < 0) Then val = -val
                        R(j, i) = CByte(val)
                    Next
                Next
            Else
                For j = 0 To H - 1
                    For i = 1 To W - 2
                        val = CInt(IMRGB(j, i - 1).R) - CInt(IMRGB(j, i + 1).R)
                        If (val < 0) Then val = -val
                        RRGB(j, i).R = CByte(val)
                        val = CInt(IMRGB(j, i - 1).G) - CInt(IMRGB(j, i + 1).G)
                        If (val < 0) Then val = -val
                        RRGB(j, i).G = CByte(val)
                        val = CInt(IMRGB(j, i - 1).B) - CInt(IMRGB(j, i + 1).B)
                        If (val < 0) Then val = -val
                        RRGB(j, i).B = CByte(val)
                    Next
                Next
            End If
            Console.WriteLine("Gradient image processed.")
            '   Save a new preview image to display in plug im!, use fnOUTPREV
            If Not (isrgb) Then
                R.Save(fnOUTPREV)
            Else
                RRGB.Save(fnOUTPREV)
            End If
        End If
        '   Save final result, use fnOUT
        If Not (isrgb) Then
            R.Save(fnOUT)
        Else
            RRGB.Save(fnOUT)
        End If
        Console.WriteLine("Process completed.")
        Environment.Exit(0)
    End Sub

End Module
